function [E1t,Ad, B1t,B2t]=c2dd (E,A,B,Te)
    // Convert continuos to discrete descriptor system
    
   
 [Phim, Phip,h]=FundMatrix(E,A); // laurent expansion
Ad=expm(Phip(:,:,1)*A*Te);


//  B1t
ePA=Phip(:,:,1)*A;
ePAt=ExpTaylor(ePA,20);
ePAtr=Trapecio(ePAt,0,Te);
B1t=ePAtr*Phip(:,:,1)*B;


//E1t
E1t=clean((Phim(:,:,1)*E-Te*eye(size(E,1),size(E,1)))^-1*Phim(:,:,1)*E);
B2t=clean(Te*(Phim(:,:,1)*E-Te*eye(size(E,1),size(E,1)))^-1*Phim(:,:,1)*B);
clc;


endfunction
