function [Pi, L1, L2, H, M, N,C11,C12]=darobsv96(E,A,B,C,F,G)
 [Ee, Ae, Ae1, Be, Be1, Ce,Fe,Fe1,De]=qrrse(E,A,B,C,F,G)

    // sizes of matrices
    n=size(E,2);
    m=size(E,1);
    r=rank(E);
    k=size(B,2);
    p=size(C,1);
    q=size(G,2);
    q1=rank(De)
    t=m+p-r;
    p1=t-q1;
    /////////////////////
    
    //////////Verifiying controllability conditions
    
    /////////////////////////////////////////////
    
    
    K=eye(n-p1,p1)
    R=rand(n-p1,n)*10;
//   R=[0 1 0 0]
//    [U,Cs, V]=svd(De); // QR factorization  
// solving $UDV=\begin{bmatrix} Iq_1 &0\\ 0 &0\end{bmatrix}$
   [U,V]=dar96gains(De)
//   pause
    UC=U*Ce;
       FV=Fe*V
   t1=rank(De);
   if rank(De)==0 then
    C11=[];
    C12=UC;
    F11=[];
    F12=FV;
else
   C11=UC(1:rank(De),:)
   C12=UC(size(UC,1)-p1+1:size(UC,1),:)
   F11=FV(1:rank(F),:);
   F12=FV(rank(F)+1:size(FV,1),:)       
   end


  
//    
Delta=clean(inv(Ee'*Ee+C12'*C12)); // between Ec. 11 and 12
varphi=clean([eye(r,r)-Ee*Delta*Ee'; -C12*Delta*Ee']);//
Phi=Ae-F11*C11;
//
aux= zeros(size(R,2),1);
auxb=eye(n-p1,n-p1);
 aux(1:size(aux,2),1:size(aux,2))=auxb;
M=inv([R;C12])*aux ;// eq. 24
//

alpha=clean(eye(r,r)-F12*pinv(varphi*F12)*varphi); // eq. between 24 and 25
//alpha=Delta*inv([Ee;C12]'*[Ee;C12])
Gamma=clean(varphi*alpha*Phi*M);
Omega=clean(R*Delta*Ee'*alpha*Phi*M)
Z=rand(1,size(varphi,1))*10;//[0 0 3 3 0 3 ]
T=(R*Delta*Ee'+Z*varphi)*alpha;

aux=zeros(n,r);
Ip1=eye(p1,p1);
aux(n-p1+1:n,:)=Ip1;
N=inv([T*Ee;C12])*aux; // eq. 25
Pi=T*Phi*M; // eq. 17
L2=T*Phi*N; // eq. 18
H=T*Be;    // eq. 5c
L1=T*F11   ; //eq. 5d
if L1==[] then
    L1=0;
end
// Theorem 1
//T*Phi-Pi*T*Ee==L2*C12
//T*F12==zeros(T*F12)
//[T*Ee;C12]*[M N]==[eye(n-p1,n-p1) zeros(p1,p1);zeros(n-p1,n-p1) eye(p1,p1)]


endfunction