function  [Pi,L, H,M, F,Be1]=redobsv95(E,A,B,C)
    
    
// This function compute the gains for recuded order Darouach observer of 1995
    
    
[Ee, Ae, Ae1, Be, Be1, Ce]=qrrse(E,A,B,C);  

//   
//pause
m=size(E,1); r=rank(Ee); k=size(B,2);
n=size(E,2);p=size(C,1);q=rank(Ce);

 // verify the controllability condition
    Rank=rank([E;Ce]);
    if Rank~=n
        error('The controllability condition is not achieved: rank([E;C]is not ""n"", the output is not observable. ') 
        return(Rank)
   end
          

K=eye(n-q,q)
R=eye(n-q,n);
Delta=inv(Ee'*Ee+Ce'*Ce); //


aux=[eye(r,r)-Ee*Delta*Ee'; -Ce*Delta*Ee'  ];
Z=rand(k,size(aux,1))*10;
T=R*Delta*Ee'+Z*aux  ; // eq.  25
M=inv([R;Ce])*[eye(n-q,n-q); zeros(q,n-q)]; //eq. 31
F=inv([T*Ee;Ce])*[zeros(k,q);eye(q,q)]; // eq. 32
Gamma=R*Delta*Ee'*Ae*M;
Omega=[(eye(r,r)-Ee*Delta*Ee')*Ae*M;-Ce*Delta*Ee'*Ae*M];
Pi=Gamma+Z*Omega;
//Pi=T*Ae*M
L=T*Ae*F
H=T*Be;
endfunction