function [xe,ye,z]=darobsv(E,A,B,C,u,poles,xx,za,Te)
    
// gains of darouach observer    
//global N K L1 L2 G a b c d 
//
//pause
for j=1:size(C,1) 

 [Ee, Ae, Ae1, Be, Be1, Ce]=qrrse(E,A,B,C(j,:));
if  N==[]  then
    
[N,K,L1,L2,G,test]=darobsv95(E,A,B,C(j,:),poles);
 [a,b,c,d,rcon]=abcdcoeff(A,B,C(j,:));
end

z(:,:,j)=rgk4(zeta,za(:,:,j),Te)
xe(:,:,j)=z(:,:,j)+b*[-Be1*u;C(j,:)*xx]+K*d*[-Be1*u;C(j,:)*xx];
ye(:,:,j)=C(j,:)*xe(:,:,j);
end
endfunction

function zz=zeta(za)
     zz=N*za+(L1+L2)*[-Be1*u;C(j,:)*xx]+G*u;
endfunction