function [A1, N, h, B1, B2, C1, C2]=kwrse  (E,A,B,C)
    // this function compute the Kronecker- Weistrauss canonical form
    [ohs,ihs]=argn(0)
    
[Q, P, n]=pencan(E,A);
P=clean(P);
Q=clean(Q);
Ae=clean(P*A*Q)
Ee=clean(P*E*Q)




Aux=size(Ee,1);

    
    
    
///....N matrix and Nilpotence Index (h)................

N=Ee(n+1:Aux,n+1:Aux);
Ne=zeros(Aux,Aux);
if norm(N)==0 then
Ne(n+1:Aux,n+1:Aux)=-eye(N);
else
Ne(n+1:Aux,n+1:Aux)=-N^0;
end

    h=1;
Ni=N;
while norm(Ni)>1e-8
    Ni=Ni*N
    h=h+1
     end
//..................................... 


A1=Ae(1:n, 1:n)


if ihs ==3 & ohs==5
Be=clean(P*B);
B1=Be(1:n,:)
B2=Be(n+1:Aux,:)


elseif (ihs==4 & ohs==7) then
Be=clean(P*B);
B1=Be(1:n,:)
B2=Be(n+1:Aux,:)

Ce=clean(C*Q);
C1=Ce(:,1:n)
C2=Ce(:,n+1:Aux)
end 

endfunction