function xd = rgk4(f,x,h)
in=argn(2);


    
//Riunge-Kutta method to solve vector differential eqn y’(t) = f(t,y(t))
//if in < 3, h = 1; end

f1 = h*f(x); //f1 = f1(:)'; //(6.3.2a)
f2 = h*f(x + f1/2); //f2 = f2(:)';//(6.3.2b)
f3 = h*f(x + f2/2); //f3 = f3(:)';//(6.3.2c)
f4 = h*f(x + f3); //f4 = f4(:)'; //(6.3.2d)
xd = x+ (f1 + 2*(f2 + f3) + f4)/6; //Eq.(6.3.1)
endfunction